property sparklePointer, sparkleOffScreenPointer, sparkleAreaPointer, iStageOffsetL, iStageOffsetT

on birth me
  set sparklePointer to EMPTY
  set sparkleOffScreenPointer to EMPTY
  set iStageOffsetL to getAt(the rect of the stage, 1)
  set iStageOffsetT to getAt(the rect of the stage, 2)
  return me
end

on loadsparkle me
  global gGraphicPath, gFileName
  set sparklePointer to blitpict(mnew)
  set sparkleOffScreenPointer to blitpict(mnew)
  set sparklePictPath to gGraphicPath & getProp(gFileName, #sparkle)
  sparklePointer(mInit, sparklePictPath, 0, 0, 0, 0, 0)
  sparkleOffScreenPointer(mInit, EMPTY, 1, 0, 0, 256, 32)
end

on sparkle me, tloc
  set H to getAt(tloc, 1)
  set V to getAt(tloc, 2)
  puppetSound("Sparkle.snd")
  updateStage()
  set cL to H - 16
  set cT to V - 16
  set cR to H + 16
  set cb to V + 16
  set sL to cL + iStageOffsetL
  set sT to cT + iStageOffsetT
  set sR to cR + iStageOffsetL
  set sB to cb + iStageOffsetT
  set sparkleAreaPointer to blitpict(mnew)
  sparkleAreaPointer(mInit, EMPTY, 1, sL, sT, sR, sB)
  repeat with n in [0, 32, 64, 96, 128, 160, 192, 224]
    sparkleAreaPointer(mDraw, 0, 0, 32, 32, sparkleOffScreenPointer, n, 0, n + 32, 32, 300, 3, 0, 1)
  end repeat
  sparklePointer(mDraw, 0, 0, 224, 32, sparkleOffScreenPointer, 0, 0, 224, 32, 0, 3, 0, 1)
  repeat with n in [0, 32, 64, 96, 128, 160, 192, 224]
    sparkleOffScreenPointer(mDraw, n, 0, n + 32, 32, sparkleOffScreenPointer, cL, cT, cR, cb, 300, 3, 1, 1)
  end repeat
  sparkleAreaPointer(mdispose)
  repeat while soundBusy(1)
  end repeat
  puppetSound(0)
end

on killsparkle me
  sparklePointer(mdispose)
  sparkleOffScreenPointer(mdispose)
end
